/*****************************  Globals   *************************************/                 
Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

/******************************  Libero ***************************************/

function nsLibero()
{
    const ExtLiberoGuid = "{30707340-352c-11da-8cd6-0800200c9a66}";

    try
    {       
        var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
        scriptLoader = scriptLoader.getService(Components.interfaces.mozIJSSubScriptLoader);
        scriptLoader.loadSubScript("chrome://web-mail/content/common/DebugLog.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/CommonPrefs.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/comms.js");
        scriptLoader.loadSubScript("chrome://libero/content/LiberoMSG.js");


        var date = new Date();
        // var  szLogFileName = "LiberoLog_" + date.getHours()+ "_" + date.getMinutes() + "_"+ date.getUTCMilliseconds() +"_";
	var  szLogFileName = "LiberoLog_";
        this.m_Log = new DebugLog("webmail.logging.comms", ExtLiberoGuid, szLogFileName); 

        this.m_Log.Write("nsLibero.js - Constructor - START");   

	this.m_szLoginCGI = null;
        this.m_bAuthorised = false;
        this.m_szUserName = null;   
        this.m_szPassWord = null; 
        this.m_oResponseStream = null;  
        this.m_HttpComms = new Comms(this , this.m_Log); 
        this.m_iStage = 0; 
        this.m_szSessionID = null;

        this.m_aMsgDataStore = new Array();
        this.m_iTotalSize = 0;

	this.m_szMsgID = 0;
        this.m_Log.Write("nsLibero.js - Constructor - END");  
    }
    catch(e)
    {
        DebugDump("nsLibero.js: Constructor : Exception : " 
                                      + e.name 
                                      + ".\nError message: " 
                                      + e.message);
    }
}



nsLibero.prototype =
{
    /* CONSTANTS */
    
	// this must match whatever is in chrome.manifest!
	classID: Components.ID("{30707340-352c-11da-8cd6-0800200c9a66}"),
	QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsIPOPDomainHandler]),

    /* METHODS */

    get userName() {return this.m_szUserName;},
    set userName(userName) {return this.m_szUserName = userName;},
  
    get passWord() {return this.m_szPassWord;},
    set passWord(passWord) {return this.m_szPassWord = passWord;},
    
    get bAuthorised() {return this.m_bAuthorised;},
  
    get ResponseStream() {return this.m_oResponseStream;},
    set ResponseStream(responseStream) {return this.m_oResponseStream = responseStream;},

    logIn : function()
    {
        try
        {
            this.m_Log.Write("nsLibero.js - logIN - START");   
            this.m_Log.Write("nsLibero.js - logIN - Username: " + this.m_szUserName 
                                                   + " Password: " + this.m_szPassWord 
                                                   + " stream: " + this.m_oResponseStream);

            if (!this.m_szUserName || !this.m_oResponseStream  || !this.m_szPassWord) return false;

		var mailAccount = "libero"
		var mailDomain = "libero.it"
		var popServerNumber = Math.floor(Math.random()*4) + 1
		var randX = Math.floor(Math.random()*15) + 1
		var randY = Math.floor(Math.random()*15) + 1

		if (this.m_szUserName.search(/@libero.it$/)!=-1 ) {
			mailAccount = "libero"
			mailDomain = "libero.it"
		}
		if (this.m_szUserName.search(/@inwind.it$/)!=-1 ) {
			mailAccount = "inwind"
			mailDomain = "inwind.libero.it"
		}
		if (this.m_szUserName.search(/@iol.it$/)!=-1 ) {
			mailAccount = "iol"
			mailDomain = "iol.libero.it"
		}
		if (this.m_szUserName.search(/@blu.it$/)!=-1 ) {
			mailAccount = "blu"
			mailDomain = "blu.libero.it"
		}

		// get starting webPage
		this.m_szLoginCGI = "http://wpop"+ popServerNumber + "." + mailDomain + "/cgi-bin/webmail.cgi"
		var loginURL=this.m_szLoginCGI + "?" + "dominio=" + mailDomain +
			"&LOGIN=" + this.m_szUserName +
			"&PASSWD=" + this.m_szPassWord +
			"&choice=" + mailAccount +
			"&Act_Login.x=" + randX +
			"&Act_Login.y=" + randY

		this.m_HttpComms.clean();
		this.m_HttpComms.setURI(loginURL);
		this.m_HttpComms.setRequestMethod("GET");
		var bResult = this.m_HttpComms.send(this.loginOnloadHandler);
		if (!bResult) throw new Error("httpConnection returned false");


            this.m_Log.Write("nsLibero.js - logIN - END");    
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsLibero.js: logIN : Exception : " 
                                              + e.name + 
                                              ".\nError message: " 
                                              + e.message);
            return false;
        }
    },


    loginOnloadHandler : function(szResponse ,event , mainObject)
    {
  
	// top.sid="IKGSzjAW8ruPBm_Lc11HhC0XCu2PLeULeqHSzTmreKOrbLu";
	// var SessionID = "IKGSzjAW8ruPBm_Lc11HhC0XCu2PLeULeqHSzTmreKOrbLu";
	const /*customize*/ PatternLiberoSessionID =/.*var SessionID = "(.*?)"/;
	const /*customize*/ alternPatternLiberoSessionID =/<frame name=\"tool_Win\" src=\"\/cgi-bin\/toolbar.cgi\?ID=(.*)\" marginwidth=/;

	// <frame name="main_Win" src="/cgi-bin/webmail.cgi?ID=IUWNv7_KTzQTEntnpmYmjcAfZeoiZVelj22nNce7bj_&Act_Msgs=1&C_Folder=aW5ib3g=" marginwidth="0 marginheight="0" scrolling="auto" frameborder="0" framespacing="0">
	const /*customize*/ PatternLiberoInboxFrame =/.*<frame name="main_Win".*src="(.*)".*/;
	
        try
        {
            mainObject.m_Log.Write("nsLibero.js - loginOnloadHandler - START"); 

		mainObject.m_Log.Write("nsLibero.js - loginOnloadHandler : " + mainObject.m_iStage);  

		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);

		//if this fails we've gone somewhere new
		mainObject.m_Log.Write("nsLibero.js - loginOnloadHandler - status :" +httpChannel.responseStatus );
		if (httpChannel.responseStatus != 200) 
			throw new Error("return status " + httpChannel.responseStatus);

		mainObject.m_HttpComms.clean();
		mainObject.m_HttpComms.setContentType(0);

		//page code
		switch (mainObject.m_iStage) {
		case 0: // we need to get sessionID first
			var sessionID = szResponse.match(PatternLiberoSessionID);
			if (sessionID == null) {
				mainObject.m_Log.Write("nsLibero.js - loginOnloadHandler - filtered logon page!");
				sessionID = szResponse.match(alternPatternLiberoSessionID);
				if (sessionID == null)
					throw new Error("error parsing libero login web page");
			}

			mainObject.m_szSessionID = sessionID[1];

			mainObject.m_Log.Write("nsLibero.js - loginOnloadHandler - SessionID = " + mainObject.m_szSessionID);

			var inboxURL = mainObject.m_szLoginCGI + "?" + "ID=" + mainObject.m_szSessionID + "&Act_Parse=login-inbox";
			mainObject.m_HttpComms.setURI(inboxURL);
			mainObject.m_HttpComms.setRequestMethod("GET");

			var bResult = mainObject.m_HttpComms.send(mainObject.loginOnloadHandler);
			if (!bResult) throw new Error("httpConnection returned false");
			mainObject.m_iStage++;
			break;

		case 1: // we need to find inbox frame
			var loginFrame = szResponse.match(PatternLiberoInboxFrame);
			if (loginFrame == null)
				throw new Error("error parsing Libero inbox frameset");

			// we're in
			mainObject.m_szMailboxURI = loginFrame[1];
			mainObject.m_Log.Write("nsLibero.js - loginOnloadHandler - szMailBox: "+ loginFrame[1]);

			//server response
			mainObject.serverComms("+OK Your in\r\n");
			mainObject.m_bAuthorised = true;
			break;
		};

            mainObject.m_Log.Write("nsLibero.js - loginOnloadHandler - END");
        }
        catch(err)
        {
            mainObject.m_Log.DebugDump("nsLibero.js: loginHandler : Exception : " 
                                          + err.name 
                                          + ".\nError message: " 
                                          + err.message);

            mainObject.serverComms("-ERR negative vibes (Libero)\r\n");
        }
    },

    //stat
    //total size is in octets
    getNumMessages : function()
    {
        try
        {
            this.m_Log.Write("nsLibero.js - getNumMessages - START"); 

		if (this.m_szMailboxURI == null) return false;
		var szMailboxURI = this.m_szLoginCGI + this.m_szMailboxURI;
		this.m_Log.Write("nsLibero.js - getNumMessages - mail box url " + szMailboxURI); 

		this.m_iStage = 0;
		this.m_HttpComms.clean();
		this.m_HttpComms.setURI(szMailboxURI);
		this.m_HttpComms.setRequestMethod("GET");
		var bResult = this.m_HttpComms.send(this.mailBoxOnloadHandler); 
		if (!bResult) throw new Error("httpConnection returned false");

            this.m_Log.Write("nsLibero.js - getNumMessages - END"); 
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsLibero.js: getNumMessages : Exception : " 
                                          + e.name 
                                          + ".\nError message: " 
                                          + e.message);
            return false;
        }
    },

    mailBoxOnloadHandler : function (szResponse ,event , mainObject)
    {
	// <script>TDEv(40);</script>&nbsp;<b>14 Kb</b>&nbsp;</TD>
	const /*customize*/ PatternLiberoMsgSizeStep1Table = /<script>TDEv\(40\);<\/script>&nbsp;(.*)&nbsp;<\/TD>/g;
	const /*customize*/ PatternLiberoMsgSizeStep2Table =/<b>(.*)<\/b>/;

	// <TD  width=165><a href="javascript:doitMsg('Act_View',1,1,'206','aW5ib3g=','aW5ib3g=','0')">
	// const PatternLiberoMsgIDTable =/<TD  width=165><a href="javascript:doitMsg\(\'Act_View\',1,1,\'(.[0-9]*).*/g;
	// <TD ALIGN=center VALIGN=middle width=20><input class=checkboxNoBorder type=checkbox id="Msg_Sel_1" name="Msg_Sel_1" value="213"></TD>
	const /*customize*/ PatternLiberoMsgIDStep1Table =/<TD.*?><input.*?value=".*?"><\/TD>/igm;
	const /*customize*/ PatternLiberoMsgIDStep2Table =/.*?value="(.*?)"><\/TD>/;

	
        try
        {
            mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler - START"); 

		mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler : " + mainObject.m_iStage);
		
		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);

		//check status should be 200.
		mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler - Mailbox :" + httpChannel.responseStatus);
		if (httpChannel.responseStatus != 200 ) 
			throw new Error("error status " + httpChannel.responseStatus);   

		mainObject.m_HttpComms.clean();

		//get message table
		var aMsgIDArray = szResponse.match(PatternLiberoMsgIDStep1Table);
		mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler - msgIDs :" + aMsgIDArray);

		if ( aMsgIDArray ) {
			var aMsgSizeArray = szResponse.match(PatternLiberoMsgSizeStep1Table);
			mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler - msgSizes :" + aMsgSizeArray);

			if ( aMsgSizeArray ) {
				if ( aMsgIDArray.lenght != aMsgSizeArray.lenght )
					throw new Error("nIDs != nSizes");

				var iNum = aMsgIDArray.length;
				mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler - msgNum :" + iNum);

				for (i = 0; i <  iNum ; i++ ) {
					var anID = aMsgIDArray[i];
					var aSize = aMsgSizeArray[i];

					var aString = anID.match(PatternLiberoMsgIDStep2Table);
					if ( aString ) {
						anID = aString[1];
					} else
						throw new Error("Error parsing MsgIDs");

					var aString = aSize.match(PatternLiberoMsgSizeStep2Table);
					if ( aString ) {
						mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler - Debug : non letto - " + aSize);
						aSize = aString[1];
					} else 
						mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler - Debug : Letto - " + aSize);

					var data = new LiberoMSG();

					data.szMsgID = anID;
					var iSize = parseInt(aSize);
					if (aSize.indexOf('K')!= -1) iSize*=1000;

					mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler - Debug :" + anID + " - " + iSize);

					data.iSize = iSize;
					mainObject.m_iTotalSize += iSize;
					mainObject.m_aMsgDataStore.push(data);
				}
			}

			mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler - Debug : totalMsgNumber=" + mainObject.m_aMsgDataStore.length );

			//check for more pages
			const /*customize*/ patternLiberoNextPage = /Act_Msgs_Page_Next/; 
			var aszNextPage = szResponse.match(patternLiberoNextPage);
			mainObject.m_Log.Write("nsLibero.js - mailBoxOnloadHandler - msg next page :" +aszNextPage);
			if (aszNextPage) {
				mainObject.m_iStage++;

				var szMailboxPageURI = mainObject.m_szLoginCGI + "?" + "ID=" + mainObject.m_szSessionID + "&Act_Msgs_Page_Next=" + mainObject.m_iNumPages + "&HELP_ID=inbox&SEL_ALL=0&From_Vu=1&C_Folder=aW5ib3g%3D&msgID=&Msg_Read=&R_Folder=&ZONEID=&Fld_P_List=aW5ib3g%3D&dummy1_List=aW5ib3g%3D&dummy2_List=aW5ib3g%3D";
				mainObject.m_Log.Write("nsLibero.js - getNumMessages - mail box page url " + szMailboxPageURI);

				mainObject.m_HttpComms.clean();
				mainObject.m_HttpComms.setURI(szMailboxPageURI);
				mainObject.m_HttpComms.setRequestMethod("GET");
				var bResult = mainObject.m_HttpComms.send(mainObject.mailBoxOnloadHandler);
				if (!bResult) throw new Error("httpConnection returned false");
			}  else {
				// no more pages report back to mozilla

				// fake empty reply
				// mainObject.serverComms("+OK "+ 0 + " " + 0 + "\r\n");

				mainObject.serverComms("+OK "+ mainObject.m_aMsgDataStore.length + " " + mainObject.m_iTotalSize + "\r\n");
				mainObject.m_iNumPages = 0;
			}
		} else {   //no emails
			mainObject.serverComms("+OK "+ mainObject.m_aMsgDataStore.length + " " + mainObject.m_iTotalSize + "\r\n");
		}

            mainObject.m_Log.Write("nsLibero.js - MailBoxOnload - END"); 
        }
        catch(err)
        {
             mainObject.m_Log.DebugDump("nsLibero.js: MailboxOnload : Exception : " 
                                              + err.name 
                                              + ".\nError message: " 
                                              + err.message);

             mainObject.serverComms("-ERR negative vibes (Libero)\r\n");
        }
    },

    //list
    //i'm not downloading the mailbox again. 
    //I hope stat been called first or there's going to be trouble
    getMessageSizes : function() 
    {
        try
        {
		this.m_Log.Write("nsLibero.js - getMessageSizes - START"); 

		// fake emply reply
		// var szPOPResponse = "+OK " + 0 + " Messages\r\n"; 

		var szPOPResponse = "+OK " + this.m_aMsgDataStore.length + " Messages\r\n"; 
		this.m_Log.Write("nsLibero.js - getMessagesSizes - : " + this.m_aMsgDataStore.length);

		for (i = 0; i <  this.m_aMsgDataStore.length; i++) {
			var data = this.m_aMsgDataStore[i];
			var iEmailSize = data.iSize;
			szPOPResponse+=(i+1) + " " + iEmailSize + "\r\n";
		}

		szPOPResponse += ".\r\n";

		this.serverComms(szPOPResponse);

            this.m_Log.Write("nsLibero.js - getMessageSizes - END"); 
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsLibero.js: getMessageSizes : Exception : " 
                                          + e.name 
                                          + ".\nError message: " 
                                          + e.message);
            return false;
        }
    },

    //IUDL
    getMessageIDs : function()
    {
        try
        {
		this.m_Log.Write("nsLibero.js - getMessageIDs - START"); 

		// fake emply reply
		// var szPOPResponse = "+OK " + 0 + " Messages\r\n"; 
		var szPOPResponse = "+OK " + this.m_aMsgDataStore.length + " Messages\r\n";
		this.m_Log.Write("nsLibero.js - getMessageIDs - return : " + this.m_aMsgDataStore.length ); 

		for (i = 0; i <  this.m_aMsgDataStore.length; i++) {
			var data = this.m_aMsgDataStore[i];
			var szEmailID = data.szMsgID;
			szPOPResponse+=(i+1) + " " + szEmailID + "\r\n";
		}

		szPOPResponse += ".\r\n";
		this.serverComms(szPOPResponse);

            this.m_Log.Write("nsLibero.js - getMessageIDs - END"); 
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsLibero.js: getMessageIDs : Exception : " 
                                          + e.name 
                                          + ".\nError message: " 
                                          + e.message);
            return false;
        }
    },

    //retr
    getMessage : function(msgIndex)
    {
        try
        {
            this.m_Log.Write("nsLibero.js - getMessage - START"); 

		//get msg id
		var oMSGData = this.m_aMsgDataStore[msgIndex-1]
		this.m_szMsgID = oMSGData.szMsgID;
		this.m_Log.Write("nsLibero.js - getMessage - msg id: " + this.m_szMsgID); 

		var getMsgParams = "/message.txt?ID=" + this.m_szSessionID + "&Act_V_Save=1&R_Folder=aW5ib3g=&msgID=" + this.m_szMsgID + "&Body=0&filename=message.txt";
		var szMsgURI = this.m_szLoginCGI + getMsgParams;

		//get message
		this.m_Log.Write("nsLibero.js - getMessage - url: "+ szMsgURI);

		//get msg from Libero
		// this.m_iStage = 0;
		this.m_HttpComms.clean();
		this.m_HttpComms.setURI(szMsgURI);
		this.m_HttpComms.setRequestMethod("GET");
		var bResult = this.m_HttpComms.send(this.emailOnloadHandler); 
		if (!bResult) throw new Error("httpConnection returned false");

            this.m_Log.Write("nsLibero.js - getMessage - END"); 
            return true;
        }
        catch(e)
        {
             this.m_Log.DebugDump("nsLibero.js: getMessage : Exception : " 
                                          + e.name + 
                                          ".\nError message: " 
                                          + e.message);
            return false;
        }
    },


    emailOnloadHandler : function (szResponse ,event , mainObject)
    {
        try
        {
		mainObject.m_Log.Write("nsLibero.js - emailOnloadHandler - START");
		mainObject.m_Log.Write("nsLibero.js - emailOnloadHandler - msg :\n" + szResponse); 

		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);
		//check status should be 200.
		if (httpChannel.responseStatus != 200) 
			throw new Error("error status " + httpChannel.responseStatus);

		var szMsg =  "X-WebMail: true\r\n";
		szMsg += szResponse;

		szMsg += ".\r\n";  //msg end 

		var szPOPResponse = "+OK " + szMsg.length + "\r\n";
		szPOPResponse += szMsg;
		mainObject.serverComms(szPOPResponse);

		mainObject.m_Log.Write("nsLibero.js - emailOnloadHandler - END");      
        }
        catch(err)
        {
		mainObject.m_Log.DebugDump("nsLibero.js: emailOnloadHandler : Exception : " 
                                          + err.name 
                                          + ".\nError message: " 
                                          + err.message);
		mainObject.serverComms("-ERR negative vibes (Libero)\r\n");
        }
    },

    //dele
    deleteMessage : function(msgIndex)
    {
        try
        {
            this.m_Log.Write("nsLibero.js - deleteMessage - START");


		//get msg id
		var oMSGData = this.m_aMsgDataStore[msgIndex-1]
		this.m_szMsgID = oMSGData.szMsgID;
		this.m_Log.Write("nsLibero.js - deleteMessage - msg id: " + this.m_szMsgID);

		var delMsgParams = "?ID=" + this.m_szSessionID +"&HELP_ID=rm_delete&Act_V_Del_CF_Ok=1&R_Folder=SU5CT1g%3D&msgID=" +this.m_szMsgID +"&Body=0";
		var szMsgURI = this.m_szLoginCGI + delMsgParams;

		//get message
		this.m_Log.Write("nsLibero.js - deleteMessage - url: "+ szMsgURI);

		//del msg from Libero
		this.m_HttpComms.clean();
		this.m_HttpComms.setURI(szMsgURI);
		this.m_HttpComms.setRequestMethod("GET");
		var bResult = this.m_HttpComms.send(this.deleteMessageOnloadHandler); 
		if (!bResult) throw new Error("httpConnection returned false");

            this.m_Log.Write("nsLibero.js - deleteMessage - END");
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsLibero.js: deleteMessage : Exception : " 
                                          + e.name + 
                                          ".\nError message: " 
                                          + e.message);
            return false;
        } 
    },

    
    deleteMessageOnloadHandler : function (szResponse ,event , mainObject)
    {
        try
        {
		mainObject.m_Log.Write("nsLibero.js - deleteMessageOnload - START");    

		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);
		//check status should be 200.
		mainObject.m_Log.Write("nsLibero.js - deleteMessageOnload :" + httpChannel.responseStatus);
		if (httpChannel.responseStatus != 200 ) 
			throw new Error("error status " + httpChannel.responseStatus);   

		mainObject.serverComms("+OK its history\r\n");      
		mainObject.m_Log.Write("nsLibero.js - deleteMessageOnload - END");      
        }
        catch(e)
        {
		mainObject.m_Log.DebugDump("nsLibero.js: deleteMessageOnload : Exception : " + e.name
                                              + ".\nError message: " 
                                              + e.message);
		mainObject.serverComms("-ERR negative vibes (Libero)\r\n");
        }
    },

    //cookies are deleted when the connection ends so i dont need to download pages
    logOut : function()
    {
        try
        {
            this.m_Log.Write("nsLibero.js - logOUT - START"); 

            this.m_bAuthorised = false;
            this.serverComms("+OK Your Out\r\n");

            this.m_Log.Write("nsLibero.js - logOUT - END");  
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsLibero.js: logOUT : Exception : " 
                                      + e.name 
                                      + ".\nError message: " 
                                      + e.message);
            return false;
        }
    },  

    serverComms : function (szMsg)
    {
        try
        { 
            this.m_Log.Write("nsLibero.js - serverComms - START");
            this.m_Log.Write("nsLibero.js - serverComms msg " + szMsg);
            var iCount = this.m_oResponseStream.write(szMsg,szMsg.length);
            this.m_Log.Write("nsLibero.js - serverComms sent count: " + iCount +" msg length: " +szMsg.length);
            this.m_Log.Write("nsLibero.js - serverComms - END");  
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsLibero.js: serverComms : Exception : " 
                                              + e.name 
                                              + ".\nError message: " 
                                              + e.message);
        }
    },
   
   
/******************************************************************************/
/***************** XPCOM  stuff ***********************************************/
/******************************************************************************/
    QueryInterface : function (iid)
    {
        if (!iid.equals(Components.interfaces.nsIPOPDomainHandler) 
        	                      	&& !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_NO_INTERFACE;
            
        return this;
    }
}
 

/******************************************************************************/
// The following line is what XPCOM uses to create components. Each component prototype
// must have a .classID which is used to create it.
const NSGetFactory = XPCOMUtils.generateNSGetFactory([nsLibero]);

